package app.serveur;

import java.util.ArrayList;
import java.util.List;

import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

@Path("CouistotService")
public class RecetteController {


	@GET
	@Produces(value = MediaType.TEXT_XML)
	@Path("AjouterRecette/{nom}/{desc}")
	public Recette ajouterRecette(@PathParam("nom") String nom, @PathParam("desc") String desc) {
		int IDNewRecette = RecetteDatabase.addRecette(nom,desc);
		
		return RecetteDatabase.getRecette(IDNewRecette);
	}
	
	@GET
	@Path("ModifierRecette/{idRecette}/{ingredients}")
	@Produces(value=MediaType.TEXT_XML)
	public Recette modifierRecette(@PathParam("idRecette") int id, @PathParam("ingredients") List<String> ingredients) throws RecetteNotFoundException {
		
		Recette r = RecetteDatabase.getRecette(id);
		if (r==null)
			throw new RecetteNotFoundException();
		
		
		r.setIngredients(ingredients);
		
		return r;
	}
	
	@GET
	@Produces(value = MediaType.TEXT_XML)
	@Path("ListeRecette")
	public List<Recette> listRecette() {
		
		return RecetteDatabase.getListe();
	}
	
	@GET
	@Path("EffacerRecette")
	public String effacerRecette(@QueryParam(value = "IDRecette") int idRecette)
	{
		Recette r = RecetteDatabase.getRecette(idRecette);
		
		if (r==null)
			return "La recette avec l'ID "+idRecette+" n'existe pas";
		else
		{
			RecetteDatabase.delRecette(r);
			return "Recette avec l'ID "+idRecette+" supprime";
		}
		
	}
	
	@POST
	@Path("SaisirRecette")
	public List<Recette> saisirRecette(
			@QueryParam("nomRecette") String nom,
			@QueryParam("descRecette") String desc,
			@QueryParam("ingrRecette") String ingr) {
		
		String[] splitIngr = ingr.split(",");
		
		RecetteDatabase.addRecette(nom, desc,splitIngr);
		
		return listRecette();
		
	}
		
}
